<?php

namespace ArtabanMarketplace\Model\Map;

use ArtabanMarketplace\Model\AmpSellerVersion;
use ArtabanMarketplace\Model\AmpSellerVersionQuery;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\InstancePoolTrait;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\DataFetcher\DataFetcherInterface;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\RelationMap;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Map\TableMapTrait;


/**
 * This class defines the structure of the 'amp_seller_version' table.
 *
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 */
class AmpSellerVersionTableMap extends TableMap
{
    use InstancePoolTrait;
    use TableMapTrait;
    /**
     * The (dot-path) name of this class
     */
    const CLASS_NAME = 'ArtabanMarketplace.Model.Map.AmpSellerVersionTableMap';

    /**
     * The default database name for this class
     */
    const DATABASE_NAME = 'thelia';

    /**
     * The table name for this class
     */
    const TABLE_NAME = 'amp_seller_version';

    /**
     * The related Propel class for this table
     */
    const OM_CLASS = '\\ArtabanMarketplace\\Model\\AmpSellerVersion';

    /**
     * A class that can be returned by this tableMap
     */
    const CLASS_DEFAULT = 'ArtabanMarketplace.Model.AmpSellerVersion';

    /**
     * The total number of columns
     */
    const NUM_COLUMNS = 32;

    /**
     * The number of lazy-loaded columns
     */
    const NUM_LAZY_LOAD_COLUMNS = 0;

    /**
     * The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS)
     */
    const NUM_HYDRATE_COLUMNS = 32;

    /**
     * the column name for the ID field
     */
    const ID = 'amp_seller_version.ID';

    /**
     * the column name for the REF field
     */
    const REF = 'amp_seller_version.REF';

    /**
     * the column name for the VISIBLE field
     */
    const VISIBLE = 'amp_seller_version.VISIBLE';

    /**
     * the column name for the ADDRESS1 field
     */
    const ADDRESS1 = 'amp_seller_version.ADDRESS1';

    /**
     * the column name for the ADDRESS2 field
     */
    const ADDRESS2 = 'amp_seller_version.ADDRESS2';

    /**
     * the column name for the ADDRESS3 field
     */
    const ADDRESS3 = 'amp_seller_version.ADDRESS3';

    /**
     * the column name for the ZIPCODE field
     */
    const ZIPCODE = 'amp_seller_version.ZIPCODE';

    /**
     * the column name for the CITY field
     */
    const CITY = 'amp_seller_version.CITY';

    /**
     * the column name for the COUNTRY_ID field
     */
    const COUNTRY_ID = 'amp_seller_version.COUNTRY_ID';

    /**
     * the column name for the EMAIL field
     */
    const EMAIL = 'amp_seller_version.EMAIL';

    /**
     * the column name for the PHONE field
     */
    const PHONE = 'amp_seller_version.PHONE';

    /**
     * the column name for the FAX field
     */
    const FAX = 'amp_seller_version.FAX';

    /**
     * the column name for the URL field
     */
    const URL = 'amp_seller_version.URL';

    /**
     * the column name for the FACEBOOK field
     */
    const FACEBOOK = 'amp_seller_version.FACEBOOK';

    /**
     * the column name for the TWITTER field
     */
    const TWITTER = 'amp_seller_version.TWITTER';

    /**
     * the column name for the PINTEREST field
     */
    const PINTEREST = 'amp_seller_version.PINTEREST';

    /**
     * the column name for the GOOGLE field
     */
    const GOOGLE = 'amp_seller_version.GOOGLE';

    /**
     * the column name for the YOUTUBE field
     */
    const YOUTUBE = 'amp_seller_version.YOUTUBE';

    /**
     * the column name for the INSTAGRAM field
     */
    const INSTAGRAM = 'amp_seller_version.INSTAGRAM';

    /**
     * the column name for the LATITUDE field
     */
    const LATITUDE = 'amp_seller_version.LATITUDE';

    /**
     * the column name for the LONGITUDE field
     */
    const LONGITUDE = 'amp_seller_version.LONGITUDE';

    /**
     * the column name for the CREATED_AT field
     */
    const CREATED_AT = 'amp_seller_version.CREATED_AT';

    /**
     * the column name for the UPDATED_AT field
     */
    const UPDATED_AT = 'amp_seller_version.UPDATED_AT';

    /**
     * the column name for the VERSION field
     */
    const VERSION = 'amp_seller_version.VERSION';

    /**
     * the column name for the VERSION_CREATED_AT field
     */
    const VERSION_CREATED_AT = 'amp_seller_version.VERSION_CREATED_AT';

    /**
     * the column name for the VERSION_CREATED_BY field
     */
    const VERSION_CREATED_BY = 'amp_seller_version.VERSION_CREATED_BY';

    /**
     * the column name for the AMP_SELLER_ADMIN_IDS field
     */
    const AMP_SELLER_ADMIN_IDS = 'amp_seller_version.AMP_SELLER_ADMIN_IDS';

    /**
     * the column name for the AMP_SELLER_ADMIN_VERSIONS field
     */
    const AMP_SELLER_ADMIN_VERSIONS = 'amp_seller_version.AMP_SELLER_ADMIN_VERSIONS';

    /**
     * the column name for the AMP_SELLER_PRODUCT_IDS field
     */
    const AMP_SELLER_PRODUCT_IDS = 'amp_seller_version.AMP_SELLER_PRODUCT_IDS';

    /**
     * the column name for the AMP_SELLER_PRODUCT_VERSIONS field
     */
    const AMP_SELLER_PRODUCT_VERSIONS = 'amp_seller_version.AMP_SELLER_PRODUCT_VERSIONS';

    /**
     * the column name for the AMP_SELLER_ORDER_IDS field
     */
    const AMP_SELLER_ORDER_IDS = 'amp_seller_version.AMP_SELLER_ORDER_IDS';

    /**
     * the column name for the AMP_SELLER_ORDER_VERSIONS field
     */
    const AMP_SELLER_ORDER_VERSIONS = 'amp_seller_version.AMP_SELLER_ORDER_VERSIONS';

    /**
     * The default string format for model objects of the related table
     */
    const DEFAULT_STRING_FORMAT = 'YAML';

    /**
     * holds an array of fieldnames
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
     */
    protected static $fieldNames = array (
        self::TYPE_PHPNAME       => array('Id', 'Ref', 'Visible', 'Address1', 'Address2', 'Address3', 'Zipcode', 'City', 'CountryId', 'Email', 'Phone', 'Fax', 'Url', 'Facebook', 'Twitter', 'Pinterest', 'Google', 'Youtube', 'Instagram', 'Latitude', 'Longitude', 'CreatedAt', 'UpdatedAt', 'Version', 'VersionCreatedAt', 'VersionCreatedBy', 'AmpSellerAdminIds', 'AmpSellerAdminVersions', 'AmpSellerProductIds', 'AmpSellerProductVersions', 'AmpSellerOrderIds', 'AmpSellerOrderVersions', ),
        self::TYPE_STUDLYPHPNAME => array('id', 'ref', 'visible', 'address1', 'address2', 'address3', 'zipcode', 'city', 'countryId', 'email', 'phone', 'fax', 'url', 'facebook', 'twitter', 'pinterest', 'google', 'youtube', 'instagram', 'latitude', 'longitude', 'createdAt', 'updatedAt', 'version', 'versionCreatedAt', 'versionCreatedBy', 'ampSellerAdminIds', 'ampSellerAdminVersions', 'ampSellerProductIds', 'ampSellerProductVersions', 'ampSellerOrderIds', 'ampSellerOrderVersions', ),
        self::TYPE_COLNAME       => array(AmpSellerVersionTableMap::ID, AmpSellerVersionTableMap::REF, AmpSellerVersionTableMap::VISIBLE, AmpSellerVersionTableMap::ADDRESS1, AmpSellerVersionTableMap::ADDRESS2, AmpSellerVersionTableMap::ADDRESS3, AmpSellerVersionTableMap::ZIPCODE, AmpSellerVersionTableMap::CITY, AmpSellerVersionTableMap::COUNTRY_ID, AmpSellerVersionTableMap::EMAIL, AmpSellerVersionTableMap::PHONE, AmpSellerVersionTableMap::FAX, AmpSellerVersionTableMap::URL, AmpSellerVersionTableMap::FACEBOOK, AmpSellerVersionTableMap::TWITTER, AmpSellerVersionTableMap::PINTEREST, AmpSellerVersionTableMap::GOOGLE, AmpSellerVersionTableMap::YOUTUBE, AmpSellerVersionTableMap::INSTAGRAM, AmpSellerVersionTableMap::LATITUDE, AmpSellerVersionTableMap::LONGITUDE, AmpSellerVersionTableMap::CREATED_AT, AmpSellerVersionTableMap::UPDATED_AT, AmpSellerVersionTableMap::VERSION, AmpSellerVersionTableMap::VERSION_CREATED_AT, AmpSellerVersionTableMap::VERSION_CREATED_BY, AmpSellerVersionTableMap::AMP_SELLER_ADMIN_IDS, AmpSellerVersionTableMap::AMP_SELLER_ADMIN_VERSIONS, AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_IDS, AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_VERSIONS, AmpSellerVersionTableMap::AMP_SELLER_ORDER_IDS, AmpSellerVersionTableMap::AMP_SELLER_ORDER_VERSIONS, ),
        self::TYPE_RAW_COLNAME   => array('ID', 'REF', 'VISIBLE', 'ADDRESS1', 'ADDRESS2', 'ADDRESS3', 'ZIPCODE', 'CITY', 'COUNTRY_ID', 'EMAIL', 'PHONE', 'FAX', 'URL', 'FACEBOOK', 'TWITTER', 'PINTEREST', 'GOOGLE', 'YOUTUBE', 'INSTAGRAM', 'LATITUDE', 'LONGITUDE', 'CREATED_AT', 'UPDATED_AT', 'VERSION', 'VERSION_CREATED_AT', 'VERSION_CREATED_BY', 'AMP_SELLER_ADMIN_IDS', 'AMP_SELLER_ADMIN_VERSIONS', 'AMP_SELLER_PRODUCT_IDS', 'AMP_SELLER_PRODUCT_VERSIONS', 'AMP_SELLER_ORDER_IDS', 'AMP_SELLER_ORDER_VERSIONS', ),
        self::TYPE_FIELDNAME     => array('id', 'ref', 'visible', 'address1', 'address2', 'address3', 'zipcode', 'city', 'country_id', 'email', 'phone', 'fax', 'url', 'facebook', 'twitter', 'pinterest', 'google', 'youtube', 'instagram', 'latitude', 'longitude', 'created_at', 'updated_at', 'version', 'version_created_at', 'version_created_by', 'amp_seller_admin_ids', 'amp_seller_admin_versions', 'amp_seller_product_ids', 'amp_seller_product_versions', 'amp_seller_order_ids', 'amp_seller_order_versions', ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, )
    );

    /**
     * holds an array of keys for quick access to the fieldnames array
     *
     * first dimension keys are the type constants
     * e.g. self::$fieldKeys[self::TYPE_PHPNAME]['Id'] = 0
     */
    protected static $fieldKeys = array (
        self::TYPE_PHPNAME       => array('Id' => 0, 'Ref' => 1, 'Visible' => 2, 'Address1' => 3, 'Address2' => 4, 'Address3' => 5, 'Zipcode' => 6, 'City' => 7, 'CountryId' => 8, 'Email' => 9, 'Phone' => 10, 'Fax' => 11, 'Url' => 12, 'Facebook' => 13, 'Twitter' => 14, 'Pinterest' => 15, 'Google' => 16, 'Youtube' => 17, 'Instagram' => 18, 'Latitude' => 19, 'Longitude' => 20, 'CreatedAt' => 21, 'UpdatedAt' => 22, 'Version' => 23, 'VersionCreatedAt' => 24, 'VersionCreatedBy' => 25, 'AmpSellerAdminIds' => 26, 'AmpSellerAdminVersions' => 27, 'AmpSellerProductIds' => 28, 'AmpSellerProductVersions' => 29, 'AmpSellerOrderIds' => 30, 'AmpSellerOrderVersions' => 31, ),
        self::TYPE_STUDLYPHPNAME => array('id' => 0, 'ref' => 1, 'visible' => 2, 'address1' => 3, 'address2' => 4, 'address3' => 5, 'zipcode' => 6, 'city' => 7, 'countryId' => 8, 'email' => 9, 'phone' => 10, 'fax' => 11, 'url' => 12, 'facebook' => 13, 'twitter' => 14, 'pinterest' => 15, 'google' => 16, 'youtube' => 17, 'instagram' => 18, 'latitude' => 19, 'longitude' => 20, 'createdAt' => 21, 'updatedAt' => 22, 'version' => 23, 'versionCreatedAt' => 24, 'versionCreatedBy' => 25, 'ampSellerAdminIds' => 26, 'ampSellerAdminVersions' => 27, 'ampSellerProductIds' => 28, 'ampSellerProductVersions' => 29, 'ampSellerOrderIds' => 30, 'ampSellerOrderVersions' => 31, ),
        self::TYPE_COLNAME       => array(AmpSellerVersionTableMap::ID => 0, AmpSellerVersionTableMap::REF => 1, AmpSellerVersionTableMap::VISIBLE => 2, AmpSellerVersionTableMap::ADDRESS1 => 3, AmpSellerVersionTableMap::ADDRESS2 => 4, AmpSellerVersionTableMap::ADDRESS3 => 5, AmpSellerVersionTableMap::ZIPCODE => 6, AmpSellerVersionTableMap::CITY => 7, AmpSellerVersionTableMap::COUNTRY_ID => 8, AmpSellerVersionTableMap::EMAIL => 9, AmpSellerVersionTableMap::PHONE => 10, AmpSellerVersionTableMap::FAX => 11, AmpSellerVersionTableMap::URL => 12, AmpSellerVersionTableMap::FACEBOOK => 13, AmpSellerVersionTableMap::TWITTER => 14, AmpSellerVersionTableMap::PINTEREST => 15, AmpSellerVersionTableMap::GOOGLE => 16, AmpSellerVersionTableMap::YOUTUBE => 17, AmpSellerVersionTableMap::INSTAGRAM => 18, AmpSellerVersionTableMap::LATITUDE => 19, AmpSellerVersionTableMap::LONGITUDE => 20, AmpSellerVersionTableMap::CREATED_AT => 21, AmpSellerVersionTableMap::UPDATED_AT => 22, AmpSellerVersionTableMap::VERSION => 23, AmpSellerVersionTableMap::VERSION_CREATED_AT => 24, AmpSellerVersionTableMap::VERSION_CREATED_BY => 25, AmpSellerVersionTableMap::AMP_SELLER_ADMIN_IDS => 26, AmpSellerVersionTableMap::AMP_SELLER_ADMIN_VERSIONS => 27, AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_IDS => 28, AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_VERSIONS => 29, AmpSellerVersionTableMap::AMP_SELLER_ORDER_IDS => 30, AmpSellerVersionTableMap::AMP_SELLER_ORDER_VERSIONS => 31, ),
        self::TYPE_RAW_COLNAME   => array('ID' => 0, 'REF' => 1, 'VISIBLE' => 2, 'ADDRESS1' => 3, 'ADDRESS2' => 4, 'ADDRESS3' => 5, 'ZIPCODE' => 6, 'CITY' => 7, 'COUNTRY_ID' => 8, 'EMAIL' => 9, 'PHONE' => 10, 'FAX' => 11, 'URL' => 12, 'FACEBOOK' => 13, 'TWITTER' => 14, 'PINTEREST' => 15, 'GOOGLE' => 16, 'YOUTUBE' => 17, 'INSTAGRAM' => 18, 'LATITUDE' => 19, 'LONGITUDE' => 20, 'CREATED_AT' => 21, 'UPDATED_AT' => 22, 'VERSION' => 23, 'VERSION_CREATED_AT' => 24, 'VERSION_CREATED_BY' => 25, 'AMP_SELLER_ADMIN_IDS' => 26, 'AMP_SELLER_ADMIN_VERSIONS' => 27, 'AMP_SELLER_PRODUCT_IDS' => 28, 'AMP_SELLER_PRODUCT_VERSIONS' => 29, 'AMP_SELLER_ORDER_IDS' => 30, 'AMP_SELLER_ORDER_VERSIONS' => 31, ),
        self::TYPE_FIELDNAME     => array('id' => 0, 'ref' => 1, 'visible' => 2, 'address1' => 3, 'address2' => 4, 'address3' => 5, 'zipcode' => 6, 'city' => 7, 'country_id' => 8, 'email' => 9, 'phone' => 10, 'fax' => 11, 'url' => 12, 'facebook' => 13, 'twitter' => 14, 'pinterest' => 15, 'google' => 16, 'youtube' => 17, 'instagram' => 18, 'latitude' => 19, 'longitude' => 20, 'created_at' => 21, 'updated_at' => 22, 'version' => 23, 'version_created_at' => 24, 'version_created_by' => 25, 'amp_seller_admin_ids' => 26, 'amp_seller_admin_versions' => 27, 'amp_seller_product_ids' => 28, 'amp_seller_product_versions' => 29, 'amp_seller_order_ids' => 30, 'amp_seller_order_versions' => 31, ),
        self::TYPE_NUM           => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, )
    );

    /**
     * Initialize the table attributes and columns
     * Relations are not initialized by this method since they are lazy loaded
     *
     * @return void
     * @throws PropelException
     */
    public function initialize()
    {
        // attributes
        $this->setName('amp_seller_version');
        $this->setPhpName('AmpSellerVersion');
        $this->setClassName('\\ArtabanMarketplace\\Model\\AmpSellerVersion');
        $this->setPackage('ArtabanMarketplace.Model');
        $this->setUseIdGenerator(false);
        // columns
        $this->addForeignPrimaryKey('ID', 'Id', 'INTEGER' , 'amp_seller', 'ID', true, null, null);
        $this->addColumn('REF', 'Ref', 'VARCHAR', true, 255, null);
        $this->addColumn('VISIBLE', 'Visible', 'TINYINT', true, null, 0);
        $this->addColumn('ADDRESS1', 'Address1', 'VARCHAR', true, 255, null);
        $this->addColumn('ADDRESS2', 'Address2', 'VARCHAR', false, 255, null);
        $this->addColumn('ADDRESS3', 'Address3', 'VARCHAR', false, 255, null);
        $this->addColumn('ZIPCODE', 'Zipcode', 'VARCHAR', true, 10, null);
        $this->addColumn('CITY', 'City', 'VARCHAR', true, 255, null);
        $this->addColumn('COUNTRY_ID', 'CountryId', 'INTEGER', true, null, null);
        $this->addColumn('EMAIL', 'Email', 'VARCHAR', false, 255, null);
        $this->addColumn('PHONE', 'Phone', 'VARCHAR', false, 255, null);
        $this->addColumn('FAX', 'Fax', 'VARCHAR', false, 255, null);
        $this->addColumn('URL', 'Url', 'VARCHAR', false, 255, null);
        $this->addColumn('FACEBOOK', 'Facebook', 'VARCHAR', false, 255, null);
        $this->addColumn('TWITTER', 'Twitter', 'VARCHAR', false, 255, null);
        $this->addColumn('PINTEREST', 'Pinterest', 'VARCHAR', false, 255, null);
        $this->addColumn('GOOGLE', 'Google', 'VARCHAR', false, 255, null);
        $this->addColumn('YOUTUBE', 'Youtube', 'VARCHAR', false, 255, null);
        $this->addColumn('INSTAGRAM', 'Instagram', 'VARCHAR', false, 255, null);
        $this->addColumn('LATITUDE', 'Latitude', 'DECIMAL', false, 16, 0);
        $this->addColumn('LONGITUDE', 'Longitude', 'DECIMAL', false, 16, 0);
        $this->addColumn('CREATED_AT', 'CreatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('UPDATED_AT', 'UpdatedAt', 'TIMESTAMP', false, null, null);
        $this->addPrimaryKey('VERSION', 'Version', 'INTEGER', true, null, 0);
        $this->addColumn('VERSION_CREATED_AT', 'VersionCreatedAt', 'TIMESTAMP', false, null, null);
        $this->addColumn('VERSION_CREATED_BY', 'VersionCreatedBy', 'VARCHAR', false, 100, null);
        $this->addColumn('AMP_SELLER_ADMIN_IDS', 'AmpSellerAdminIds', 'ARRAY', false, null, null);
        $this->addColumn('AMP_SELLER_ADMIN_VERSIONS', 'AmpSellerAdminVersions', 'ARRAY', false, null, null);
        $this->addColumn('AMP_SELLER_PRODUCT_IDS', 'AmpSellerProductIds', 'ARRAY', false, null, null);
        $this->addColumn('AMP_SELLER_PRODUCT_VERSIONS', 'AmpSellerProductVersions', 'ARRAY', false, null, null);
        $this->addColumn('AMP_SELLER_ORDER_IDS', 'AmpSellerOrderIds', 'ARRAY', false, null, null);
        $this->addColumn('AMP_SELLER_ORDER_VERSIONS', 'AmpSellerOrderVersions', 'ARRAY', false, null, null);
    } // initialize()

    /**
     * Build the RelationMap objects for this table relationships
     */
    public function buildRelations()
    {
        $this->addRelation('AmpSeller', '\\ArtabanMarketplace\\Model\\AmpSeller', RelationMap::MANY_TO_ONE, array('id' => 'id', ), 'CASCADE', null);
    } // buildRelations()

    /**
     * Adds an object to the instance pool.
     *
     * Propel keeps cached copies of objects in an instance pool when they are retrieved
     * from the database. In some cases you may need to explicitly add objects
     * to the cache in order to ensure that the same objects are always returned by find*()
     * and findPk*() calls.
     *
     * @param \ArtabanMarketplace\Model\AmpSellerVersion $obj A \ArtabanMarketplace\Model\AmpSellerVersion object.
     * @param string $key             (optional) key to use for instance map (for performance boost if key was already calculated externally).
     */
    public static function addInstanceToPool($obj, $key = null)
    {
        if (Propel::isInstancePoolingEnabled()) {
            if (null === $key) {
                $key = serialize(array((string) $obj->getId(), (string) $obj->getVersion()));
            } // if key === null
            self::$instances[$key] = $obj;
        }
    }

    /**
     * Removes an object from the instance pool.
     *
     * Propel keeps cached copies of objects in an instance pool when they are retrieved
     * from the database.  In some cases -- especially when you override doDelete
     * methods in your stub classes -- you may need to explicitly remove objects
     * from the cache in order to prevent returning objects that no longer exist.
     *
     * @param mixed $value A \ArtabanMarketplace\Model\AmpSellerVersion object or a primary key value.
     */
    public static function removeInstanceFromPool($value)
    {
        if (Propel::isInstancePoolingEnabled() && null !== $value) {
            if (is_object($value) && $value instanceof \ArtabanMarketplace\Model\AmpSellerVersion) {
                $key = serialize(array((string) $value->getId(), (string) $value->getVersion()));

            } elseif (is_array($value) && count($value) === 2) {
                // assume we've been passed a primary key";
                $key = serialize(array((string) $value[0], (string) $value[1]));
            } elseif ($value instanceof Criteria) {
                self::$instances = [];

                return;
            } else {
                $e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or \ArtabanMarketplace\Model\AmpSellerVersion object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value, true)));
                throw $e;
            }

            unset(self::$instances[$key]);
        }
    }

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     */
    public static function getPrimaryKeyHashFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        // If the PK cannot be derived from the row, return NULL.
        if ($row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)] === null && $row[TableMap::TYPE_NUM == $indexType ? 23 + $offset : static::translateFieldName('Version', TableMap::TYPE_PHPNAME, $indexType)] === null) {
            return null;
        }

        return serialize(array((string) $row[TableMap::TYPE_NUM == $indexType ? 0 + $offset : static::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)], (string) $row[TableMap::TYPE_NUM == $indexType ? 23 + $offset : static::translateFieldName('Version', TableMap::TYPE_PHPNAME, $indexType)]));
    }

    /**
     * Retrieves the primary key from the DB resultset row
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, an array of the primary key columns will be returned.
     *
     * @param array  $row       resultset row.
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM
     *
     * @return mixed The primary key of the row
     */
    public static function getPrimaryKeyFromRow($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {

            return $pks;
    }

    /**
     * The class that the tableMap will make instances of.
     *
     * If $withPrefix is true, the returned path
     * uses a dot-path notation which is translated into a path
     * relative to a location on the PHP include_path.
     * (e.g. path.to.MyClass -> 'path/to/MyClass.php')
     *
     * @param boolean $withPrefix Whether or not to return the path with the class name
     * @return string path.to.ClassName
     */
    public static function getOMClass($withPrefix = true)
    {
        return $withPrefix ? AmpSellerVersionTableMap::CLASS_DEFAULT : AmpSellerVersionTableMap::OM_CLASS;
    }

    /**
     * Populates an object of the default type or an object that inherit from the default.
     *
     * @param array  $row       row returned by DataFetcher->fetch().
     * @param int    $offset    The 0-based offset for reading from the resultset row.
     * @param string $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                 One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                           TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     * @return array (AmpSellerVersion object, last column rank)
     */
    public static function populateObject($row, $offset = 0, $indexType = TableMap::TYPE_NUM)
    {
        $key = AmpSellerVersionTableMap::getPrimaryKeyHashFromRow($row, $offset, $indexType);
        if (null !== ($obj = AmpSellerVersionTableMap::getInstanceFromPool($key))) {
            // We no longer rehydrate the object, since this can cause data loss.
            // See http://www.propelorm.org/ticket/509
            // $obj->hydrate($row, $offset, true); // rehydrate
            $col = $offset + AmpSellerVersionTableMap::NUM_HYDRATE_COLUMNS;
        } else {
            $cls = AmpSellerVersionTableMap::OM_CLASS;
            $obj = new $cls();
            $col = $obj->hydrate($row, $offset, false, $indexType);
            AmpSellerVersionTableMap::addInstanceToPool($obj, $key);
        }

        return array($obj, $col);
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @param DataFetcherInterface $dataFetcher
     * @return array
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function populateObjects(DataFetcherInterface $dataFetcher)
    {
        $results = array();

        // set the class once to avoid overhead in the loop
        $cls = static::getOMClass(false);
        // populate the object(s)
        while ($row = $dataFetcher->fetch()) {
            $key = AmpSellerVersionTableMap::getPrimaryKeyHashFromRow($row, 0, $dataFetcher->getIndexType());
            if (null !== ($obj = AmpSellerVersionTableMap::getInstanceFromPool($key))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj->hydrate($row, 0, true); // rehydrate
                $results[] = $obj;
            } else {
                $obj = new $cls();
                $obj->hydrate($row);
                $results[] = $obj;
                AmpSellerVersionTableMap::addInstanceToPool($obj, $key);
            } // if key exists
        }

        return $results;
    }
    /**
     * Add all the columns needed to create a new object.
     *
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param Criteria $criteria object containing the columns to add.
     * @param string   $alias    optional table alias
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria, $alias = null)
    {
        if (null === $alias) {
            $criteria->addSelectColumn(AmpSellerVersionTableMap::ID);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::REF);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::VISIBLE);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::ADDRESS1);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::ADDRESS2);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::ADDRESS3);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::ZIPCODE);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::CITY);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::COUNTRY_ID);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::EMAIL);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::PHONE);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::FAX);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::URL);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::FACEBOOK);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::TWITTER);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::PINTEREST);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::GOOGLE);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::YOUTUBE);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::INSTAGRAM);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::LATITUDE);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::LONGITUDE);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::CREATED_AT);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::UPDATED_AT);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::VERSION);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::VERSION_CREATED_AT);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::VERSION_CREATED_BY);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::AMP_SELLER_ADMIN_IDS);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::AMP_SELLER_ADMIN_VERSIONS);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_IDS);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_VERSIONS);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::AMP_SELLER_ORDER_IDS);
            $criteria->addSelectColumn(AmpSellerVersionTableMap::AMP_SELLER_ORDER_VERSIONS);
        } else {
            $criteria->addSelectColumn($alias . '.ID');
            $criteria->addSelectColumn($alias . '.REF');
            $criteria->addSelectColumn($alias . '.VISIBLE');
            $criteria->addSelectColumn($alias . '.ADDRESS1');
            $criteria->addSelectColumn($alias . '.ADDRESS2');
            $criteria->addSelectColumn($alias . '.ADDRESS3');
            $criteria->addSelectColumn($alias . '.ZIPCODE');
            $criteria->addSelectColumn($alias . '.CITY');
            $criteria->addSelectColumn($alias . '.COUNTRY_ID');
            $criteria->addSelectColumn($alias . '.EMAIL');
            $criteria->addSelectColumn($alias . '.PHONE');
            $criteria->addSelectColumn($alias . '.FAX');
            $criteria->addSelectColumn($alias . '.URL');
            $criteria->addSelectColumn($alias . '.FACEBOOK');
            $criteria->addSelectColumn($alias . '.TWITTER');
            $criteria->addSelectColumn($alias . '.PINTEREST');
            $criteria->addSelectColumn($alias . '.GOOGLE');
            $criteria->addSelectColumn($alias . '.YOUTUBE');
            $criteria->addSelectColumn($alias . '.INSTAGRAM');
            $criteria->addSelectColumn($alias . '.LATITUDE');
            $criteria->addSelectColumn($alias . '.LONGITUDE');
            $criteria->addSelectColumn($alias . '.CREATED_AT');
            $criteria->addSelectColumn($alias . '.UPDATED_AT');
            $criteria->addSelectColumn($alias . '.VERSION');
            $criteria->addSelectColumn($alias . '.VERSION_CREATED_AT');
            $criteria->addSelectColumn($alias . '.VERSION_CREATED_BY');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ADMIN_IDS');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ADMIN_VERSIONS');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_PRODUCT_IDS');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_PRODUCT_VERSIONS');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ORDER_IDS');
            $criteria->addSelectColumn($alias . '.AMP_SELLER_ORDER_VERSIONS');
        }
    }

    /**
     * Returns the TableMap related to this object.
     * This method is not needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function getTableMap()
    {
        return Propel::getServiceContainer()->getDatabaseMap(AmpSellerVersionTableMap::DATABASE_NAME)->getTable(AmpSellerVersionTableMap::TABLE_NAME);
    }

    /**
     * Add a TableMap instance to the database for this tableMap class.
     */
    public static function buildTableMap()
    {
      $dbMap = Propel::getServiceContainer()->getDatabaseMap(AmpSellerVersionTableMap::DATABASE_NAME);
      if (!$dbMap->hasTable(AmpSellerVersionTableMap::TABLE_NAME)) {
        $dbMap->addTableObject(new AmpSellerVersionTableMap());
      }
    }

    /**
     * Performs a DELETE on the database, given a AmpSellerVersion or Criteria object OR a primary key value.
     *
     * @param mixed               $values Criteria or AmpSellerVersion object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, ConnectionInterface $con = null)
     {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerVersionTableMap::DATABASE_NAME);
        }

        if ($values instanceof Criteria) {
            // rename for clarity
            $criteria = $values;
        } elseif ($values instanceof \ArtabanMarketplace\Model\AmpSellerVersion) { // it's a model object
            // create criteria based on pk values
            $criteria = $values->buildPkeyCriteria();
        } else { // it's a primary key, or an array of pks
            $criteria = new Criteria(AmpSellerVersionTableMap::DATABASE_NAME);
            // primary key is composite; we therefore, expect
            // the primary key passed to be an array of pkey values
            if (count($values) == count($values, COUNT_RECURSIVE)) {
                // array is not multi-dimensional
                $values = array($values);
            }
            foreach ($values as $value) {
                $criterion = $criteria->getNewCriterion(AmpSellerVersionTableMap::ID, $value[0]);
                $criterion->addAnd($criteria->getNewCriterion(AmpSellerVersionTableMap::VERSION, $value[1]));
                $criteria->addOr($criterion);
            }
        }

        $query = AmpSellerVersionQuery::create()->mergeWith($criteria);

        if ($values instanceof Criteria) { AmpSellerVersionTableMap::clearInstancePool();
        } elseif (!is_object($values)) { // it's a primary key, or an array of pks
            foreach ((array) $values as $singleval) { AmpSellerVersionTableMap::removeInstanceFromPool($singleval);
            }
        }

        return $query->delete($con);
    }

    /**
     * Deletes all rows from the amp_seller_version table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public static function doDeleteAll(ConnectionInterface $con = null)
    {
        return AmpSellerVersionQuery::create()->doDeleteAll($con);
    }

    /**
     * Performs an INSERT on the database, given a AmpSellerVersion or Criteria object.
     *
     * @param mixed               $criteria Criteria or AmpSellerVersion object containing data that is used to create the INSERT statement.
     * @param ConnectionInterface $con the ConnectionInterface connection to use
     * @return mixed           The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *         rethrown wrapped into a PropelException.
     */
    public static function doInsert($criteria, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerVersionTableMap::DATABASE_NAME);
        }

        if ($criteria instanceof Criteria) {
            $criteria = clone $criteria; // rename for clarity
        } else {
            $criteria = $criteria->buildCriteria(); // build Criteria from AmpSellerVersion object
        }


        // Set the correct dbName
        $query = AmpSellerVersionQuery::create()->mergeWith($criteria);

        try {
            // use transaction because $criteria could contain info
            // for more than one table (I guess, conceivably)
            $con->beginTransaction();
            $pk = $query->doInsert($con);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollBack();
            throw $e;
        }

        return $pk;
    }

} // AmpSellerVersionTableMap
// This is the static code needed to register the TableMap for this table with the main Propel class.
//
AmpSellerVersionTableMap::buildTableMap();
